package cn.com.infosec.asn1.esf;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERSequence;

public class SigPolicyQualifierInfo extends ASN1Encodable {
   private DERObjectIdentifier sigPolicyQualifierId;
   private DEREncodable sigQualifier;

   public SigPolicyQualifierInfo(DERObjectIdentifier sigPolicyQualifierId, DEREncodable sigQualifier) {
      this.sigPolicyQualifierId = sigPolicyQualifierId;
      this.sigQualifier = sigQualifier;
   }

   public SigPolicyQualifierInfo(ASN1Sequence seq) {
      this.sigPolicyQualifierId = DERObjectIdentifier.getInstance(seq.getObjectAt(0));
      this.sigQualifier = seq.getObjectAt(1);
   }

   public static SigPolicyQualifierInfo getInstance(Object obj) {
      if (obj != null && !(obj instanceof SigPolicyQualifierInfo)) {
         if (obj instanceof ASN1Sequence) {
            return new SigPolicyQualifierInfo((ASN1Sequence)obj);
         } else {
            throw new IllegalArgumentException("unknown object in 'SigPolicyQualifierInfo' factory: " + obj.getClass().getName() + ".");
         }
      } else {
         return (SigPolicyQualifierInfo)obj;
      }
   }

   public DERObjectIdentifier getSigPolicyQualifierId() {
      return this.sigPolicyQualifierId;
   }

   public DEREncodable getSigQualifier() {
      return this.sigQualifier;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.sigPolicyQualifierId);
      var10000.add(this.sigQualifier);
      return new DERSequence(var1);
   }
}
